//-----------------------------------------------------------------------------
// Project            	GeometryKit
// Class		G3DVector4d
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The GeometryKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DVector4d.h,v 1.5 2001/01/05 20:50:50 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DVector4d_h_INCLUDE
#define __G3DVector4d_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/G3DTuple4d.h>

@interface G3DVector4d : G3DTuple4d
{
}

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (G3DVector4d *)vector4d;
+ (G3DVector4d *)vector4dWithValues:(double *)vals;
+ (G3DVector4d *)vector4dWithX:(double)x y:(double)y z:(double)z w:(double)w;
+ (G3DVector4d *)vector4dWithVector4d:(G3DVector4d *)vec;

//-----------------------------------------------------------------------------
// init and free
//-----------------------------------------------------------------------------

- (id)initWithVector:(G3DVector4d *)vec;

//-----------------------------------------------------------------------------
// Math
//-----------------------------------------------------------------------------

- (G3DVector4d *)vectorByAdding:(G3DVector4d *)aVector;
- (G3DVector4d *)vectorBySubtracting:(G3DVector4d *)aVector;

- (G3DVector4d *)vectorByMultiplyingBy:(double)aScalar;
- (G3DVector4d *)vectorByDividingBy:(double)aScalar;

- (double)dotProduct:(G3DVector4d *)aVec;

- (double)length;

- (double)squaredLength;

- (void)normalise;

- (G3DVector4d *)normalisedVector;

@end

#endif







